<template>
  <Loading v-if="$fetchState.pending && !$fetchState.error"></Loading>
  <Error v-else-if="$fetchState.error" :error="$fetchState.error"></Error>
  <div v-else>
    <ExploreBoard v-if="scenarios.length" pretitle="explore" title="scenarios">
      <template #header-right>
        <div class="btn-list justify-content-end">
          <div class="d-none d-sm-inline">
            <a
              class="btn mr-1m rimow-step-by-step-guide mode-simple toggle-mode-visible visible cursor-pointer"
              @click="initIntro()"
            >
              <DirectionsIcon />
              Step-by-step guide
            </a>
          </div>
          <a
            href="#"
            class="btn btn-primary scenario-new d-none d-sm-inline-block disabled"
          >
            <BulbIcon />
            Suggest a new scenario
          </a>
        </div>
      </template>
      <template #panel-left>
        <div class="nav-search-explore">
          <div class="mb-3">
            <div class="nav-search-explore-form">
              <div data-intro="This input allows you to search for scenarios">
                <ExploreSearchBox
                  placeholder="Search in scenarios…"
                  item-type="scenarios"
                  :first="search.meta.first"
                  :last="search.meta.last"
                  :total="scenarios.length"
                  @search="setSearchValue"
                >
                </ExploreSearchBox>
              </div>
            </div>
          </div>
          <ExploreSearchFilters
            :search-fields="searchFilter.fields"
            :sort-fields="searchFilter.sort"
            :defaults="searchFilter.defaults"
            direction="Descending"
            @filtersChanged="filtersChanged"
          />
        </div>
      </template>
      <template #main-content>
        <div
          v-if="filteredScenarios.length"
          class="rimow-card-deck row row-deck results-found"
        >
          <div
            v-for="scenario in filteredScenarios"
            :key="scenario.index"
            class="rimow-card card-sce col-sm-6 col-lg-4 mb-2"
          >
            <ScenarioCard :scenario="scenario" />
          </div>
        </div>
        <EmptyData
          v-else
          title="No Scenario found"
          description="No Scenario found for your search"
          image="/illustrations/no-scenarios-found.svg"
        >
        </EmptyData>
      </template>
    </ExploreBoard>
    <EmptyData
      v-else
      title="There are no scenarios yet"
      image="/illustrations/no-scenarios-found.svg"
    ></EmptyData>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import searchFilterMixin from '~/mixins/search-filter.js';
export default {
  mixins: [searchFilterMixin],
  layout: 'dashboard',
  middleware: 'auth',
  data() {
    return {
      filteredScenarios: [],
      filters: {
        filterBy: [{ filterBy: 'title' }],
        orderBy: 'date.creation',
        direction: 'Descending',
      },
      valueToSearch: '',
      search: {
        meta: {
          first: 1,
          last: 0,
        },
      },
    };
  },
  async fetch() {
    await this.$nuxt.context.store.dispatch('scenarios/fetchScenarios');
    this.filtersChanged(this.filters);
  },
  head() {
    return {
      title: 'Scenarios - RISIS Workspace',
    };
  },
  computed: {
    ...mapGetters({
      scenarios: 'scenarios/allScenarios',
    }),
    searchFilter() {
      return {
        fields: [
          {
            text: 'Name',
            filterBy: 'title',
          },
          {
            text: 'Inputs',
            filterBy: 'inputs.query.title',
          },
          {
            text: 'Tags',
            filterBy: 'tags',
          },
          {
            text: 'Author',
            filterBy: 'owners',
          },
          {
            text: 'Description',
            filterBy: 'description',
          },
        ],
        sort: [
          {
            text: 'Date',
            filterBy: 'date.creation',
          },
          {
            text: 'Title',
            filterBy: 'title',
          },
          {
            text: 'Inputs',
            filterBy: 'inputs.query.title',
          },
          {
            text: 'Tags',
            filterBy: 'tags',
          },
        ],
      };
    },
  },
  watch: {
    scenarios() {
      this.filtersChanged(this.filters);
    },
  },
  methods: {
    setSearchValue(valueToSearch) {
      this.valueToSearch = valueToSearch;
      this.filtersChanged(this.filters);
    },
    filtersChanged(filters) {
      this.filters = filters;
      this.filteredScenarios = this.searchFunction(
        this.valueToSearch,
        this.scenarios,
        this.filters
      );
      this.filteredScenarios = this.applyFilter(
        this.filters,
        this.filteredScenarios
      );
      this.search.meta.last = this.filteredScenarios.length;
    },
    initIntro() {
      this.$store.commit('ui/showIntroJs');
    },
  },
};
</script>
